<template>
  <div class="white-block">
    <hr>
    <div class="padding">
      <h3>Идентификация</h3>
    </div>
    <hr>
    <div class="padding">
      <p>Ответьте на несколько вопросов (не более 5) по вашей кредитной истории. Это необходимо, чтобы мы могли
        идентифицировать Вас. Это последний этап перед отправкой заявки.</p>
      <p v-show="application">Пожалуйста, отнеситесь внимательно к заполнению ответов на вопросы о Вашей кредитной истории. Корректное
        заполнение позволит значительно ускорить рассмотрение заявки и избежать дополнительных вопросов по
        телефону.<br>
        Внимание!<br>
        Ответы на следующие вопросы не влияют на решение о предоставлении Вам займа, а служат исключительно для целей
        идентификации.</p>
    </div>
    <hr>
    <div v-if="typeCreditProduct">
      <!--Растановка галочек-->
      <div v-if="question">
        <div class="padding">
          <div class="row">
            <div class="columns center">
              <h3>Какие типы действующих кредитных продуктов у вас есть?</h3>
            </div>
          </div>
        </div>
        <hr>
        <div class="padding">
          <p>Пожалуйста выберите все типы кредитных продуктов, по которым у вас имеется непогашенная задолженность, или,
            в случае кредитных карт, открытый кредитный лимит.</p>
          <div class="row">
            <!--Ипотека-->
            <div class="columns checkbox">
              <input type="checkbox"
                     name="mortgage_agree"
                     id="mortgage_agree"
                     @click="checkedTypeCredit"
                     v-model="user.creditHistory.hasMortgage"
                     @change="setValue('hasMortgage')"
                     value="0"
              >
              <label for="mortgage_agree"> <span></span>Ипотека</label>
            </div>
          </div>
          <div class="row">
            <!--Автокредит-->
            <div class="columns checkbox">
              <input type="checkbox"
                     name="auto_loan_agree"
                     id="auto_loan_agree"
                     @click="checkedTypeCredit"
                     v-model="user.creditHistory.hasAutoCredit"
                     @change="setValue('hasAutoCredit')"
                     value="1"
              >
              <label for="auto_loan_agree"> <span></span>Автокредит</label>
            </div>
          </div>
          <div class="row">
            <!--Кредитная карта-->
            <div class="columns checkbox">
              <input type="checkbox"
                     name="credit_card_agree"
                     id="credit_card_agree"
                     @click="checkedTypeCredit"
                     v-model="user.creditHistory.hasCreditCard"
                     @change="setValue('hasCreditCard')"
                     value="2"
              >
              <label for="credit_card_agree"> <span></span>Кредитная карта</label>
            </div>
          </div>
          <div class="row">
            <!--Потребительский кредит (займ, микрозайм)-->
            <div class="columns checkbox">
              <input type="checkbox"
                     name="consumer_credit_agree"
                     @click="checkedTypeCredit"
                     v-model="user.creditHistory.hasLoan"
                     id="consumer_credit_agree"
                     @change="setValue('hasLoan')"
                     value="3"
              >
              <label for="consumer_credit_agree"> <span></span>Потребительский кредит (займ, микрозайм)</label>
            </div>
          </div>
          <div class="row">
            <!--У меня нет действующих кредитных продуктов-->
            <div class="columns checkbox">
              <input type="checkbox"
                     name="no_credit_agree"
                     id="no_credit_agree"
                     @click="checkedTypeCredit"
                     v-model="user.creditHistory.hasNoCredit"
                     value="4"
                     @change="setValue('hasNoCredit')"
              >
              <label for="no_credit_agree"> <span></span>У меня нет действующих кредитных продуктов</label>
            </div>
            <div class="columns twelve" :class="{without_credit:isActive}">
              (При отсутствии кредитной истории мы не сможем идентифицировать вас дистанционно. В этом случае выдача займа возможна только через систему переводов "Контакт". Для получения денег вам нужно будет подойти с паспортом в ближайшее отделение банка, сотрудничающее с системой "Контакт".)
            </div>
          </div>
        </div>
        <div class="padding">
          <div class="row">
            <div class="center">
              <button disabled class="white">Назад</button>
              <button :disabled="tickCheck" @click="ticked">Вперед</button>
            </div>
          </div>
        </div>
      </div>
      <!--Форма с доп. вопросами-->
      <div v-else>
        <!--Ипотека-->
        <div v-if="selectedData[index] === 'hasMortgage'">
          <div v-if="nextStepCheck">
            <div class="padding">
              <h3>Какую сумму предоставил вам банк по самому большому из ваших действующих ипотечных кредитов?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="mortgageSum">Сумма</label>
                  <input
                    id="mortgageSum"
                    type="text"
                    name="по ипотеке"
                    v-validate="'required|min:4'"
                    v-mask="'#######'"
                    v-model="user.creditHistory.mortgageSum"
                    @input="setValue('mortgageSum')"
                    @keyup="verificationOfDataEntryAmount"
                  >
                  <validate-message
                    v-show="vErrors.has('по ипотеке')"
                  >{{ vErrors.first('по ипотеке') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="mortgageCurrency">Валюта</label>
                  <multiselect v-model="fieldCurrencyMortgage"
                               :options="currencyMortgageStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="mortgageCurrency"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getCurrencyMortgage"
                               :vValidateRules = "'required'"
                               name="ипотека"
                               :value="currencyMortgage"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('ипотека')"
                  >{{ vErrors.first('ипотека') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>
          <div v-else>
            <div class="padding">
              <h3>На какой срок был предоставлен этот кредит?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="mortgageTerm">Срок</label>
                  <input
                    id="mortgageTerm"
                    type="text"
                    name="mortgageTerm"
                    v-validate="'required|min:1'"
                    v-mask="'###'"
                    v-model="user.creditHistory.mortgageTerm"
                    @input="setValue('mortgageTerm')"
                    @keyup="verificationOfDataEntry"
                  >
                  <validate-message
                    v-show="vErrors.has('mortgageTerm')"
                  >{{ vErrors.first('mortgageTerm') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="mortgageTypeDate">Дата</label>
                  <multiselect v-model="fieldDateMortgage"
                               name="срок погашения ипотеки"
                               :options="dateMortgageStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="mortgageTypeDate"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getDateMortgage"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('срок погашения ипотеки')"
                               :value="dateMortgage"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('срок погашения ипотеки')"
                  >{{ vErrors.first('срок погашения ипотеки') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>
        </div>


        <!--Автокредит-->
        <div v-if="(selectedData[index] === 'hasAutoCredit')">
          <div v-if="nextStepCheck">
            <div class="padding">
              <h3>Какую сумму предоставил вам банк по самому большому из ваших действующих автокредитов?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="autoCreditSum">Сумма</label>
                  <input
                    id="autoCreditSum"
                    type="text"
                    name="по автокредиту"
                    v-validate="'required|min:4'"
                    v-mask="'#######'"
                    v-model="user.creditHistory.autoCreditSum"
                    @input="setValue('autoCreditSum')"
                    @keyup="verificationOfDataEntryAmount"
                  >
                  <validate-message
                    v-show="vErrors.has('по автокредиту')"
                  >{{ vErrors.first('по автокредиту') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="autoCreditCurrency">Валюта</label>
                  <multiselect v-model="fieldCurrencyAutoCredit"
                               name="валюта автокредита"
                               :options="currencyAutoCreditStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="autoCreditCurrency"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getCurrencyAutoCredit"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('валюта автокредита')"
                               :value="currencyAutoCredit"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('валюта автокредита')"
                  >{{ vErrors.first('валюта автокредита') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>

          <div v-else>
            <div class="padding">
              <h3>На какой срок был предоставлен этот кредит?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="autoCreditTerm">Срок</label>
                  <input
                    id="autoCreditTerm"
                    type="text"
                    name="autoCreditTerm"
                    v-validate="'required|min:1'"
                    v-mask="'###'"
                    v-model="user.creditHistory.autoCreditTerm"
                    @input="setValue('autoCreditTerm')"
                    @keyup="verificationOfDataEntry"
                  >

                  <validate-message
                    v-show="vErrors.has('autoCreditTerm')"
                  >{{ vErrors.first('autoCreditTerm') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="autoCreditTypeDate">Дата</label>
                  <multiselect v-model="fieldDateAutoCredit"
                               name="срок погашения автокредита"
                               :options="dateAutoCreditStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="autoCreditTypeDate"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getDateAutoCredit"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('срок погашения автокредита')"
                               :value="dateAutoCredit"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('срок погашения автокредита')"
                  >{{ vErrors.first('срок погашения автокредита') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>
        </div>

        <!--Кредитная карта-->
        <div v-if="selectedData[index] === 'hasCreditCard'">
          <div v-if="nextStepCheck">
            <div class="padding">
              <h3>Какой лимит предоставил вам банк по действующей кредитной карте (если у вас несколько кредитных карт,
                выберите карту с максимальным лимитом)?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="creditCardLimit">Сумма</label>
                  <input
                    id="creditCardLimit"
                    type="text"
                    name="по кредитной карте"
                    v-validate="'required|min:4'"
                    v-mask="'#######'"
                    v-model="user.creditHistory.creditCardLimit"
                    @input="setValue('creditCardLimit')"
                    @keyup="verificationOfDataEntryAmount"
                  >
                  <validate-message
                    v-show="vErrors.has('по кредитной карте')"
                  >{{ vErrors.first('по кредитной карте') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="creditCardCurrency">Валюта</label>
                  <multiselect v-model="fieldCurrencyCreditCard"
                               name="валюта используемой кредитной картой"
                               :options="currencyCreditCardStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="creditCardCurrency"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getCurrencyCreditCard"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('валюта используемой кредитной картой')"
                               :value="currencyCreditCard"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('валюта используемой кредитной картой')"
                  >{{ vErrors.first('валюта используемой кредитной картой') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>

          <div v-else>
            <div class="padding">
              <h3>До какого года действительна эта карта?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="creditCardTermMonth">Месяц</label>
                  <multiselect v-model="fieldMonthCreditCard"
                               name="месяц окончания использования кредитной картой"
                               :options="monthCreditCardStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="creditCardTermMonth"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getMonthCreditCard"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('месяц окончания использования кредитной картой')"
                               :value="monthCreditCard"
                    >
                    </multiselect>
                  <validate-message
                    v-show="vErrors.has('месяц окончания использования кредитной картой')"
                  >{{ vErrors.first('месяц окончания использования кредитной картой') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="creditCardTermYear">Год</label>
                  <multiselect v-model="fieldYearCreditCard"
                               name="год окончания использования кредитной картой"
                               :options="yearCreditCardStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="creditCardTermYear"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getYearCreditCard"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('год окончания использования кредитной картой')"
                               :value="yearCreditCard"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('год окончания использования кредитной картой')"
                  >{{ vErrors.first('год окончания использования кредитной картой') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>
        </div>

        <!--Потребительский займ-->
        <div v-if="selectedData[index] === 'hasLoan'">
          <div v-if="nextStepCheck">
            <div class="padding">
              <h3>Какую сумму предоставил вам банк (или другая кредитная организация) по самому большому из ваших действующих потребительских кредитов (займов, микрозаймов)?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="loanSum">Сумма</label>
                  <input
                    id="loanSum"
                    type="text"
                    name="по потребительскому кредиту"
                    v-validate="'required|min:4'"
                    v-mask="'#######'"
                    v-model="user.creditHistory.loanSum"
                    @input="setValue('loanSum')"
                    @keyup="verificationOfDataEntryAmount"
                  >
                  <validate-message
                    v-show="vErrors.has('по потребительскому кредиту')"
                  >{{ vErrors.first('по потребительскому кредиту') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="loanCurrency">Валюта</label>
                  <multiselect v-model="fieldCurrencyConsumerCredit"
                               name="срок погашения других кредитов"
                               :options="currencyConsumerCreditStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="loanCurrency"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getCurrencyConsumerCredit"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('срок погашения других кредитов')"
                               :value="currencyConsumerCredit"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('срок погашения других кредитов')"
                  >{{ vErrors.first('срок погашения других кредитов') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>

          <div v-else>
            <div class="padding">
              <h3>На какой срок был предоставлен этот кредит?</h3>
            </div>
            <hr>
            <div class="padding">
              <div class="row">
                <div class="columns six">
                  <label for="loanTerm">Срок</label>
                  <input
                    id="loanTerm"
                    type="text"
                    name="loanTerm"
                    v-validate="'required|min:1'"
                    v-mask="'###'"
                    v-model="user.creditHistory.loanTerm"
                    @input="setValue('loanTerm')"
                    @keyup="verificationOfDataEntry"
                  >
                  <validate-message
                    v-show="vErrors.has('loanTerm')"
                  >{{ vErrors.first('loanTerm') }}
                  </validate-message>
                </div>
                <div class="columns six">
                  <label for="loanTypeDate">Дата</label>
                  <multiselect v-model="fieldDateConsumerCredit"
                               name="срок погашения других кредитов"
                               :options="dateConsumerCreditStatus"
                               :searchable="false"
                               :close-on-select="true"
                               :show-labels="false"
                               placeholder=""
                               id="loanTypeDate"
                               :preserve-search="true"
                               label="title"
                               track-by="id"
                               @input="getDateConsumerCredit"
                               :vValidateRules="'required'"
                               v-validate="'required'"
                               :class="getValidateClass('срок погашения других кредитов')"
                               :value="dateConsumerCredit"
                  >
                  </multiselect>
                  <validate-message
                    v-show="vErrors.has('срок погашения других кредитов')"
                  >{{ vErrors.first('срок погашения других кредитов') }}
                  </validate-message>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!--Кнопки для проверки-->
        <div class="padding">
          <div class="row">
            <div class="center">
              <button class="white" @click="backStep">Назад</button>
              <button :disabled="disabledNextStep" @click="nextStep">Вперед</button>
            </div>
          </div>
        </div>
      </div>

    </div>

    <!--Подговленный отчет с вопросами для проверки-->
    <div v-else>
      <div class="padding margin-top-30" v-if="this.user.creditHistory.hasNoCredit">
        <div class="row">
          <div class="columns center">
            {{loadAndCheckTypeHistory}}
            <h3>У меня нет действующих кредитных продуктов</h3>
          </div>
        </div>
      </div>
      <div v-else>
        <final-question></final-question>
      </div>
      <div class="padding margin-bottom-30">
        <div class="row">
          <div class="columns center">
            <span>Пожалуйста, проверьте Ваши ответы. Если в них есть ошибка, вы можете <a @click="idenficationAgain"> пройти идентификацию еще раз.</a></span>
          </div>
        </div>
      </div>
      <warning-message></warning-message>
      <div class="center"><button @click="historyOver">Продолжить</button></div>
    </div>
    <!--Конец отчета-->
  </div>
</template>

<script>
  import IndicatorRegistration from '@/mixins/IndicatorRegistration'
  import UserGetter from '@/mixins/User/UserGetterMixin'
  import UserSetter from '@/mixins/User/UserSetterMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import ValidateMessage from '@/components/Validators/ValidateMessage'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'
  import FinalQuestion from './FinalQuestion'
  import {SET_CREDIT_HISTORY_DONE} from '@/store/mutation-types'
  import Multiselect from '@/UI/Multiselect'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import backendApi from '@/utils/backend-api'
  import WarningMessage from '@/components/AuxiliaryWindows/WarningMessage'

  let defaultPeriod = [{id: 1, title: 'Год(а)/лет'}]

  let period = [
    {id: 1, title: 'Год(а)/лет'},
    {id: 2, title: 'Месяц(а/ев)'}
  ]

  let defaultPay = [{id: 1, title: 'Рублей'}]

  let pay = [
    {id: 1, title: 'Рублей'},
    {id: 2, title: 'Американских долларов'},
    {id: 3, title: 'Евро'},
    {id: 4, title: 'Швейцарских франков'},
    {id: 5, title: 'Другое'}
  ]

  export default {
    name: 'identification',
    mixins: [
      IndicatorRegistration,
      UserGetter,
      UserSetter,
      UserErrorText,
      GetValidateClass,
      ErrorHandleMixin
    ],
    components: {
      ValidateMessage,
      FinalQuestion,
      Multiselect,
      WarningMessage
    },
    data () {
      return {
        application: true,
        typeCreditProduct: true,
        question: true,
        isActive: false,
        tickCheck: true,
        histories: false,
        getArrayCredits: '',
        filterArrayCredits: '',
        selectedData: '',
        index: 0,
        nextStepCheck: true,
        disabledNextStep: true,
        fieldCurrencyMortgage: defaultPay,
        currencyMortgageStatus: pay,
        fieldDateMortgage: defaultPeriod,
        dateMortgageStatus: period,
        fieldCurrencyAutoCredit: defaultPay,
        currencyAutoCreditStatus: pay,
        fieldDateAutoCredit: defaultPeriod,
        dateAutoCreditStatus: period,
        fieldCurrencyCreditCard: defaultPay,
        currencyCreditCardStatus: pay,
        fieldCurrencyConsumerCredit: defaultPay,
        currencyConsumerCreditStatus: pay,
        fieldDateConsumerCredit: defaultPeriod,
        dateConsumerCreditStatus: period,
        fieldMonthCreditCard: [{id: 1, title: '01'}],
        monthCreditCardStatus: [
          {id: 1, title: '01'},
          {id: 2, title: '02'},
          {id: 3, title: '03'},
          {id: 4, title: '04'},
          {id: 5, title: '05'},
          {id: 6, title: '06'},
          {id: 7, title: '07'},
          {id: 8, title: '08'},
          {id: 9, title: '09'},
          {id: 10, title: '10'},
          {id: 11, title: '11'},
          {id: 12, title: '12'}
        ],
        fieldYearCreditCard: [{id: 1, title: '2018'}],
        yearCreditCardStatus: [
          {id: 1, title: '2018'},
          {id: 2, title: '2019'},
          {id: 3, title: '2020'},
          {id: 4, title: '2021'},
          {id: 5, title: '2022'},
          {id: 6, title: '2023'},
          {id: 7, title: '2024'},
          {id: 8, title: '2025'},
          {id: 9, title: '2026'}
        ]
      }
    },
    computed: {
      currencyMortgage () {
        this.fieldCurrencyMortgage = this.currencyMortgageStatus[this.user.creditHistory.mortgageCurrency - 1]
      },
      dateMortgage () {
        this.fieldDateMortgage = this.dateMortgageStatus[this.user.creditHistory.mortgageTypeDate - 1]
      },
      currencyAutoCredit () {
        this.fieldCurrencyAutoCredit = this.currencyAutoCreditStatus[this.user.creditHistory.autoCreditCurrency - 1]
      },
      dateAutoCredit () {
        this.fieldDateAutoCredit = this.dateAutoCreditStatus[this.user.creditHistory.autoCreditTypeDate - 1]
      },
      currencyCreditCard () {
        this.fieldCurrencyAutoCredit = this.currencyAutoCreditStatus[this.user.creditHistory.creditCardCurrency - 1]
      },
      currencyConsumerCredit () {
        this.fieldCurrencyConsumerCredit = this.currencyConsumerCreditStatus[this.user.creditHistory.loanCurrency - 1]
      },
      dateConsumerCredit () {
        this.fieldDateConsumerCredit = this.dateConsumerCreditStatus[this.user.creditHistory.loanTypeDate - 1]
      },
      monthCreditCard () {
        this.fieldMonthCreditCard = this.monthCreditCardStatus[this.user.creditHistory.creditCardTermMonth - 1]
      },
      yearCreditCard () {
        this.fieldYearCreditCard = this.yearCreditCardStatus[this.user.creditHistory.creditCardTermYear - 1]
      },
      loadAndCheckTypeHistory () {
        let history = this.user.creditHistory
        if (!history.hasMortgage) {
          history.mortgageSum = null
          history.mortgageCurrency = 1
          history.mortgageTerm = null
          history.mortgageTypeDate = 1
        }
        if (!history.hasAutoCredit) {
          history.autoCreditSum = null
          history.autoCreditCurrency = 1
          history.autoCreditTerm = null
          history.autoCreditTypeDate = 1
        }
        if (!history.hasCreditCard) {
          history.creditCardLimit = null
          history.creditCardCurrency = 1
          history.creditCardTermYear = 1
          history.creditCardTermMonth = 1
        }
        if (!history.hasLoan) {
          history.loanSum = null
          history.loanCurrency = 1
          history.loanTerm = null
          history.loanTypeDate = 1
        }
      }
    },
    methods: {
      checkedTypeCredit ({target}) {
        let typeCredit = this.user.creditHistory
        if (target.value !== '4') {
          typeCredit.hasNoCredit = false
          this.isActive = false
        }
        if (target.value === '4') {
          typeCredit.hasMortgage = false
          typeCredit.hasAutoCredit = false
          typeCredit.hasCreditCard = false
          typeCredit.hasLoan = false
          this.isActive = true
        }
      },
      verificationOfDataEntry (e) {
        if (e.target.value.length >= 1) {
          this.disabledNextStep = false
        } else {
          this.disabledNextStep = true
        }
      },
      verificationOfDataEntryAmount (e) {
        if (e.target.value.length >= 4) {
          this.disabledNextStep = false
        } else {
          this.disabledNextStep = true
        }
      },
      getParamsForQuestion () {
        this.getArrayCredits = Object.entries(this.user.creditHistory)
        this.filterArrayCredits = this.getArrayCredits.map((n) => {
          if (n[1] === true) {
            return n[0]
          }
        })
        this.selectedData = this.filterArrayCredits.filter((x) => {
          return x !== undefined
        })
      },
      getCurrencyMortgage (arg) {
        this.user.creditHistory.mortgageCurrency = arg.id
        this.updateUser(this.user)
      },
      getDateMortgage (arg) {
        this.user.creditHistory.mortgageTypeDate = arg.id
        this.updateUser(this.user)
      },
      getCurrencyAutoCredit (arg) {
        this.user.creditHistory.autoCreditCurrency = arg.id
        this.updateUser(this.user)
      },
      getDateAutoCredit (arg) {
        this.user.creditHistory.autoCreditTypeDate = arg.id
        this.updateUser(this.user)
      },
      getCurrencyCreditCard (arg) {
        this.user.creditHistory.creditCardCurrency = arg.id
        this.updateUser(this.user)
      },
      getCurrencyConsumerCredit (arg) {
        this.user.creditHistory.loanCurrency = arg.id
        this.updateUser(this.user)
      },
      getDateConsumerCredit (arg) {
        this.user.creditHistory.loanTypeDate = arg.id
        this.updateUser(this.user)
      },
      getMonthCreditCard (arg) {
        this.disabledNextStep = false
        this.user.creditHistory.creditCardTermMonth = arg.id
        this.updateUser(this.user)
      },
      getYearCreditCard (arg) {
        this.disabledNextStep = false
        this.user.creditHistory.creditCardTermYear = arg.id
        this.updateUser(this.user)
      },
      ticked () {
        console.log('312312312', this.histories)
        if (this.histories) {
          if (this.user.creditHistory.hasNoCredit) {
            this.typeCreditProduct = false
            this.$store.commit(SET_CREDIT_HISTORY_DONE, true)
            this.application = false
            this.getParamsForQuestion()
          } else {
            this.question = false
            this.getParamsForQuestion()
          }
        } else {
          this.question = true
        }
      },
      backStep () {
        if (this.nextStepCheck) {
          this.question = true
          this.disabledNextStep = false
        } else {
          this.nextStepCheck = true
        }
      },
      nextStep () {
        if (this.nextStepCheck) {
          this.nextStepCheck = false
          this.disabledNextStep = true
        } else {
          this.nextStepCheck = true
          this.index++
          this.disabledNextStep = true
          if (this.index === this.selectedData.length) {
            this.typeCreditProduct = false
            this.$store.commit(SET_CREDIT_HISTORY_DONE, true)
            this.application = false
          }
        }
      },
      idenficationAgain () {
        this.application = true
        this.question = true
        this.typeCreditProduct = true
        this.user.creditHistory.hasMortgage = false
        this.user.creditHistory.hasAutoCredit = false
        this.user.creditHistory.hasCreditCard = false
        this.user.creditHistory.hasLoan = false
        this.user.creditHistory.hasNoCredit = false
        this.index = 0
        this.tickCheck = true
        this.isActive = false
        this.loadAndCheckTypeHistory()
      },
      historyOver () {
        let his = this.user.creditHistory
        backendApi.putData('credit-history/create', {
          hasMortgage: his.hasMortgage,
          mortgageSum: his.mortgageSum,
          mortgageCurrency: his.mortgageCurrency,
          mortgageTerm: his.mortgageTerm,
          mortgageTypeDate: his.mortgageTypeDate,
          hasAutoCredit: his.hasAutoCredit,
          autoCreditSum: his.autoCreditSum,
          autoCreditCurrency: his.autoCreditCurrency,
          autoCreditTerm: his.autoCreditTerm,
          autoCreditTypeDate: his.autoCreditTypeDate,
          hasCreditCard: his.hasCreditCard,
          creditCardLimit: his.creditCardLimit,
          creditCardCurrency: his.creditCardCurrency,
          creditCardTermYear: this.getYear(),
          creditCardTermMonth: his.creditCardTermMonth,
          hasLoan: his.hasLoan,
          loanSum: his.loanSum,
          loanCurrency: his.loanCurrency,
          loanTerm: his.loanTerm,
          loanTypeDate: his.loanTypeDate
        })
          .then(() => {
            this.$store.state.user.user.creditHistory.historyIsFull = true
            this.updateUser(this.user)
          })
          .catch((error) => {
            let arg = error.errors[0].code
            switch (arg) {
              // ошибки по ипотеке
              case 'hasMortgageNotBoolean':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'mortgageSumNotNumeric':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе ипотека. Укажите данные ввиде суммы')
                break
              case 'mortgageSumInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе ипотека. В поле разрешено вводить только цифры. Укажите данные ввиде суммы')
                break
              case 'mortgageSumNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе ипотека. Сумма должна быть больше 0')
                break
              case 'mortgageCurrencyInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'mortgageCurrencyNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'mortgageTermInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле период в разделе ипотека. В поле разрешено вводить только цифры. Укажите данные ввиде числа')
                break
              case 'mortgageTermNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле период в разделе ипотека. Срок должнен быть больше 0 месяцев (годов)')
                break
              case 'mortgageTypeDateInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'mortgageTypeDateNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              // ошибки по автокредиту
              case 'hasAutoCreditNotBoolean':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'autoCreditSumInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе ипотека. В поле разрешено вводить только цифры. Укажите данные ввиде суммы')
                break
              case 'autoCreditSumNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе автокредита. Сумма должна быть больше 0')
                break
              case 'autoCreditCurrencyInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'autoCreditCurrencyNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'autoCreditTermInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле период в разделе автокредит. В поле разрешено вводить только цифры. Укажите данные ввиде числа')
                break
              case 'autoCreditTermNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле период в разделе автокредит. Срок должнен быть больше 0 месяцев (годов)')
                break
              case 'autoCreditTypeDateInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'autoCreditTypeDateNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              // ошибки по кредитной карте
              case 'hasLoanNotBoolean':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'creditCardLimitInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе кредитная карта. В поле разрешено вводить только цифры. Укажите данные ввиде суммы')
                break
              case 'creditCardLimitNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе кредитная карта. Сумма должна быть больше 0')
                break
              case 'creditCardCurrencyInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'creditCardCurrencyNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'creditCardTermMonthInvalidDateFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно указан месяц в разделе кредитный карты. Карта должна быть действительной')
                break
              case 'creditCardTermYearInvalidDateFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно указан год в разделе кредитный карты. Карта должна быть действительной')
                break
              case 'creditCardTermIncorrectTerm':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              // ошибки по текущему кредиту
              case 'hasCreditCardNotBoolean':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'loanSumInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе потребительский кредит (займ, микрозайм). В поле разрешено вводить только цифры. Укажите данные ввиде суммы')
                break
              case 'loanSumNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле суммы в разделе потребительский кредит (займ, микрозайм). Сумма должна быть больше 0')
                break
              case 'loanCurrencyInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'loanCurrencyNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'loanTermInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле период в разделе потребительский кредит (займ, микрозайм). В поле разрешено вводить только цифры. Укажите данные ввиде числа')
                break
              case 'loanTermNotGreaterThan':
                this.$store.commit('CALL_WARNING_WINDOW', 'Некорректно заполнено поле период в разделе потребительский кредит (займ, микрозайм). Срок должнен быть больше 0 месяцев (годов)')
                break
              case 'loanTypeDateInvalidFormat':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
              case 'loanTypeDateNotInAvailableRange':
                this.$store.commit('CALL_WARNING_WINDOW', 'Внутрення ошибка. Пожалуйста, перезагрузите страницу и повторите опрос еще раз')
                break
            }
          })
      },
      getYear () {
        switch (this.user.creditHistory.creditCardTermYear) {
          case 1:
            return '2018'
          case 2:
            return '2019'
          case 3:
            return '2020'
          case 4:
            return '2021'
          case 5:
            return '2022'
          case 6:
            return '2023'
          case 7:
            return '2024'
          case 8:
            return '2025'
          case 9:
            return '2026'
        }
      }
    },
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
    },
    updated () {
      let typeCredit = this.user.creditHistory
      if ((typeCredit.hasMortgage) || (typeCredit.hasAutoCredit) || (typeCredit.hasCreditCard) || (typeCredit.hasLoan) || (typeCredit.hasNoCredit)) {
        this.tickCheck = false
        this.histories = true
      } else {
        this.tickCheck = true
        this.histories = false
        this.isActive = false
      }
    }
  }
</script>

<style scoped>
  a{
    text-decoration: none;
    cursor: pointer;
  }
  .margin-bottom-30 {
    margin-bottom: 30px;
  }
  .margin-top-30 {
    margin-bottom: -30px;
  }
  .twelve{
    font-size: 11px;
  }
  .without_credit{
    font-weight: bold;
  }
  .checkbox{
    margin-bottom: 0 !important;
  }
</style>




